Torque2D Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | List of all members
b2PolygonShape Class Reference

`#include <b2PolygonShape.h>`

Inheritance diagram for b2PolygonShape:

## Public Member Functions
| b2PolygonShape ()
b2Shape * | Clone (b2BlockAllocator *allocator) const
| Implement b2Shape. More...
int32 | GetChildCount () const
void | Set (const b2Vec2 *points, int32 count)
void | SetAsBox (float32 hx, float32 hy)
void | SetAsBox (float32 hx, float32 hy, const b2Vec2 &center, float32 angle)
bool | TestPoint (const b2Transform &transform, const b2Vec2 &p) const
bool | RayCast (b2RayCastOutput *output, const b2RayCastInput &input, const b2Transform &transform, int32 childIndex) const
| Implement b2Shape. More...
void | ComputeAABB (b2AABB *aabb, const b2Transform &transform, int32 childIndex) const
void | ComputeMass (b2MassData *massData, float32 density) const
int32 | GetVertexCount () const
| Get the vertex count. More...
const b2Vec2 & | GetVertex (int32 index) const
| Get a vertex by index. More...
bool | Validate () const
Public Member Functions inherited from b2Shape
virtual | ~b2Shape ()
Type | GetType () const

## Public Attributes
b2Vec2 | m_centroid
b2Vec2 | m_vertices [b2_maxPolygonVertices]
b2Vec2 | m_normals [b2_maxPolygonVertices]
int32 | m_count
Public Attributes inherited from b2Shape
Type | m_type
float32 | m_radius

## Additional Inherited Members
Public Types inherited from b2Shape
enum | Type { e_circle = 0, e_edge = 1, e_polygon = 2, e_chain = 3, e_typeCount = 4 }

## Detailed Description

A convex polygon. It is assumed that the interior of the polygon is to the left of each edge. Polygons have a maximum number of vertices equal to b2_maxPolygonVertices. In most cases you should not need many vertices for a convex polygon.

## Constructor & Destructor Documentation

b2PolygonShape | ( |  | ) |
| inline

## Member Function Documentation

b2Shape * Clone | ( | b2BlockAllocator * | allocator | ) | const
| virtual

Implement b2Shape.

Implements b2Shape.

void ComputeAABB | ( | b2AABB * | aabb,
|  | const b2Transform & | transform,
|  | int32 | childIndex
| ) |  | const
| virtual

See also
  b2Shape::ComputeAABB

Implements b2Shape.

void ComputeMass | ( | b2MassData * | massData,
|  | float32 | density
| ) |  | const
| virtual

See also
  b2Shape::ComputeMass

Implements b2Shape.

int32 GetChildCount | ( |  | ) | const
| virtual

See also
  b2Shape::GetChildCount

Implements b2Shape.

const b2Vec2 & GetVertex | ( | int32 | index | ) | const
| inline

Get a vertex by index.

int32 GetVertexCount | ( |  | ) | const
| inline

Get the vertex count.

bool RayCast | ( | b2RayCastOutput * | output,
|  | const b2RayCastInput & | input,
|  | const b2Transform & | transform,
|  | int32 | childIndex
| ) |  | const
| virtual

Implement b2Shape.

Implements b2Shape.

void Set | ( | const b2Vec2 * | points,
|  | int32 | count
| ) |  |

Create a convex hull from the given array of local points. The count must be in the range [3, b2_maxPolygonVertices].

Warning
  the points may be re-ordered, even if they form a convex polygon
  collinear points are handled but not removed. Collinear points may lead to poor stacking behavior.

void SetAsBox | ( | float32 | hx,
|  | float32 | hy
| ) |  |

Build vertices to represent an axis-aligned box centered on the local origin.

Parameters

  hx | the half-width.
  hy | the half-height.

void SetAsBox | ( | float32 | hx,
|  | float32 | hy,
|  | const b2Vec2 & | center,
|  | float32 | angle
| ) |  |

Build vertices to represent an oriented box.

Parameters

  hx | the half-width.
  hy | the half-height.
  center | the center of the box in local coordinates.
  angle | the rotation of the box in local coordinates.

bool TestPoint | ( | const b2Transform & | transform,
|  | const b2Vec2 & | p
| ) |  | const
| virtual

See also
  b2Shape::TestPoint

Implements b2Shape.

bool Validate | ( |  | ) | const

Validate convexity. This is a very time consuming operation.

Returns
  true if valid

## Member Data Documentation

b2Vec2 m_centroid

int32 m_count

b2Vec2 m_normals[b2_maxPolygonVertices]

b2Vec2 m_vertices[b2_maxPolygonVertices]

The documentation for this class was generated from the following files:

- Box2D/Collision/Shapes/b2PolygonShape.h
- Box2D/Collision/Shapes/b2PolygonShape.cpp